#include <math.h>
#include <stdio.h>
#include "gfx.h"

#define THR 1.8

#define NPIX 32

void frame()
{
  int x,y;
  int R= 5;
  static int k;
  for(x=0;x<NPIX;x++) for(y=0;y<NPIX;y++) set_pixel(x,y,0);

  for(y=-R-5;y<=R+5;y++)
    for(x=-R-5;x<=R+5;x++)
    {
       double D;
       int V;
       D= fabs(sqrt(x*x+y*y)-R);
       if (D>THR) continue;
       //D= (1.1-D)/1.1;
       D= (THR-D)/THR;
       V= D*255;
       if (V>255) V= 255;
       if (V<0) V= 0;
       set_pixel(x+NPIX/2, y+NPIX/2, (V<<16) | (V<<8) | V);

    }

  if (k%2)
  {
  R= 2;
  for(y=-R-5;y<=R+5;y++)
    for(x=-R-5;x<=R+5;x++)
    {
       double D;
       int V;
       D= sqrt(x*x+y*y);
       if (D<R) { V= 255; } else 
       {
       D-= R;
       if (D>THR) continue;
       //D= (1.1-D)/1.1;
       D= (THR-D)/THR;
       V= D*255;
       if (V>255) V= 255;
       if (V<0) V= 0;
       }
       set_pixel(x+NPIX/2, y+NPIX/2, (V<<16) | (V<<8) | V);

    }
  }
  k++;
  draw();
}

int main()
{
  int x,y;
  pixinit(&x,&y);
  gfx_button(1, x, y, 80, 30, "Frame", GFXEV_LAST+3);
  while(1)
  {
    gfx_event_t event;
    pixevent(&event);
    switch(event.type)
    {
    case GFXEV_LAST+3: frame(); break;
    case GFXEV_QUIT: goto done;
    }
  }
done:
  gfx_close();
  return 0;
}

